# This program helps to prove the combinatorial Theorem for a given triple
# The positive roots are numbered and displayed
# You have to init the data giving beta, gamma, gamma+beta (gammab)
# and gamma-beta (gmb). Set gmb at -1 if gamma-beta  is not a root.
# Liste0y is a list of roots known to not belong to Phi_2 (e.g. by lower rank or previous cases).
# The program uses convexity, coconvexity and Phi3 is the disjoint union of Phi1 and Phi2 Until finding a contradiction.

# The intermediate situations are displayed. For each root, 3 integers give the situation relatively to Phi_3,Phi_1 and Phi_2.
# 0 means the root does not belong, 1 means the root belongs, -1 means unknown at this step.

type = input('Entrer le type (entre quotes) : ')
rk = input('Entrer le rang : ')


print DynkinDiagram([type,rk])
Root=RootSystem([type,rk])


# INITIALISATION
#Toprove= [6, 8, 9, 10, 11, 12, 13, 16]
beta= 3
gamma= 18
gammab= 17
Liste0y= [8,12,13,16]
gmb=-1
phi=4
print 'beta,gamma,gamma+beta : ',[beta,gamma,gammab]

Nbposroots=0
i=0
for a in Root.root_lattice().positive_roots() :
    Nbposroots=Nbposroots+1
    print i,' : ',[a[j+1] for j in range(rk)];
    i=i+1


def Affiche(w,x,y):
    i=0
    for a in Root.root_lattice().positive_roots() :
        print i,' : ',[a[j+1] for j in range(rk)],' : ',w[i],' : ',x[i],' : ',y[i];
        i=i+1

print 'The are ',Nbposroots,' positive roots'

def position(a,Phip) :
    k=0
    for b in Root.root_lattice().positive_roots() :
        if a == b : return k
        k=k+1
    return -1

Tripleabaplusb=[]
i=0
for a in Root.root_lattice().positive_roots() :
    j=0
    for b in Root.root_lattice().positive_roots() :
        if a+b in Root.root_lattice().positive_roots() :
            Tripleabaplusb.append([i,j,position(a+b,Root.root_lattice().positive_roots())])
        j=j+1    
    i=i+1
def complete_one_step(v,st) : # v is a vector with 0 (not in), 1 (in), -1 (I don't know)
    w=vector(ZZ,Nbposroots)
    for i in range(Nbposroots) : w[i]=v[i]
    for [i,j,k] in Tripleabaplusb :
        if (v[i]==0) and (v[j]==0) :
            if v[k]==1 :
                print 'r',k,'=r',i,'+r',j
                print 'r',i,' and r',j,' do not belong to Phi',st,', but r',k,' do. Contradiction.'
                sys.exit(1)
            w[k]=0
            # if (v[k]==-1) and (k==22): print 'k0',[i,j,k],v[i],v[j],v[k]
            # uncomment to prove that the root 22 does not belong to some Phi_i
        if (v[i]==1) and (v[j]==1) :
            if v[k]==0 :
                print 'r',k,'=r',i,'+r',j
                print 'r',i,' and r',j,' belong to Phi',st,', but r',k,' not. Contradiction.'
                sys.exit(1)
            w[k]=1
            # if (v[k]==-1) and (k==22): print 'k0',[i,j,k],v[i],v[j],v[k]
            # uncomment to prove that the root 22  belongs to some Phi_i
        if (v[k]==0) and (v[i]==1) :
            w[j]=0
            #if (v[j]==-1) and (j==22) : print 'j0',[i,j,k],v[i],v[j],v[k]
            # uncomment to prove that the root 22 does not belong to some Phi_i
        if (v[k]==1) and (v[i]==0) :
            w[j]=1
            #if (v[j]==-1) and (j==22): print 'j',[i,j,k],v[i],v[j],v[k]
            # uncomment to prove that the root 22  belongs to some Phi_i
    return w

def complete(v,st) :
    vp=v
    vpp=complete_one_step(v,st)
    while vpp != vp :
       vp=vpp
       vpp=complete_one_step(v,st)
    return vp

def horizontal_transfert(vw,vx,vy):
    ww=vector(ZZ,Nbposroots);wx=vector(ZZ,Nbposroots);wy=vector(ZZ,Nbposroots)
    for i in range(Nbposroots) : ww[i]=vw[i]; wx[i]=vx[i]; wy[i]=vy[i];
    for i in range(Nbposroots) :
        if vx[i]==1 :
            if (vy[i]==1) or (vw[i]==0) :
                print 'Contradiction with the disjoint union for the root number', i
                sys.exit(1)
            wy[i]=0
            ww[i]=1
        elif vy[i]==1 :
            if (vx[i]==1) or (vw[i]==0) :
                print 'Contradiction with the disjoint union for the root number', i
                sys.exit(1)
            wx[i]=0
            ww[i]=1
        elif (vx[i]==0) and (vy[i]==0):
            if vw[i]==1 :
                print 'Contradiction with the disjoint union for the root number', i
                sys.exit(1)
            vw[i]=0    
        elif ww[i]==0 :
           if (vx[i]==1) or (vy[i]==1):
               print 'Contradiction with the disjoint union for the root number', i
               sys.exit(1)
           wx[i]=0;wy[i]=0    
        elif ww[i]==1 :
            if (vx[i]==0) and (vy[i]==0):
                print 'Contradiction with the disjoint union for the root number', i
                sys.exit(1)
            if (vx[i]==0) : wy[i]=1
            if (vy[i]==0) : wx[i]=1
        elif (vx[i]==vy[i]) : ww[i]=vx[i]
    return [ww,wx,wy]

v=vector(ZZ,Nbposroots)
for i in range(Nbposroots) : v[i]=-1


vx=vector(ZZ,Nbposroots)
for i in range(Nbposroots) : vx[i]=-1
vx[beta]=1
vx[gamma]=0
vx[gammab]=1
#if phi>=0 : vx[phi]=0
#vx[8]=0 # WARNING TMP

vw=vector(ZZ,Nbposroots)
for i in range(Nbposroots) : vw[i]=-1
vw[beta]=1
vw[gamma]=0
vw[gammab]=1
#if phi>=0 : vw[phi]=1
# gamma-beta ATTENTION : EXCEPTIONNEL
if gmb>=0 : vw[gmb]=0


vy=vector(ZZ,Nbposroots)
for i in range(Nbposroots) : vy[i]=-1

vy[beta]=0
vy[gamma]=0
vy[gammab]=0
if phi>=0 : vy[phi]=1
for i in Liste0y : vy[i]=0
#vy[23]=0
    
[vw,vx,vy]=horizontal_transfert(vw,vx,vy)
print 'Initial setting:'
Affiche(vw,vx,vy)


##### On commence a deduire


vy2=complete(vy,'2')
vw2=complete(vw,'3')
vx2=complete(vx,'1')


print 'After 1 using of (co)convexity :'

Affiche(vw2,vx2,vy2)


[w1,x1,y1]=horizontal_transfert(vw2,vx2,vy2)


vw2=complete(w1,'3')
vx2=complete(x1,'1')
vy2=complete(y1,'2')


print 'After 2 usings of (co)convexity:'


Affiche(vw2,vx2,vy2)

[w2,x2,y2]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w2,'3')
vx2=complete(x2,'1')
vy2=complete(y2,'2')

print 'After 3:'

Affiche(vw2,vx2,vy2)

[w3,x3,y3]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w3,'3')
vx2=complete(x3,'1')
vy2=complete(y3,'2')

print 'After 4:'

Affiche(vw2,vx2,vy2)


[w4,x4,y4]=horizontal_transfert(vw2,vx2,vy2)

vw2=complete(w4,'3')
vx2=complete(x4,'1')
vy2=complete(y4,'2')

print 'After 5:'

Affiche(vw2,vx2,vy2)
[w5,x5,y5]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w5,'3')
vx2=complete(x5,'1')
vy2=complete(y5,'2')


print 'After 6:'
Affiche(vw2,vx2,vy2)
[w6,x6,y6]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w6,'3')
vx2=complete(x6,'1')
vy2=complete(y6,'2')

print 'After 7:'
print vw2,vx2,vy2
Affiche(vw2,vx2,vy2)
[w7,x7,y7]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w7,'3')
vx2=complete(x7,'1')
vy2=complete(y7,'2')

print 'After 8:'
Affiche(vw2,vx2,vy2)
[w8,x8,y8]=horizontal_transfert(vw2,vx2,vy2)
vw2=complete(w8,'3')
vx2=complete(x8,'1')
vy2=complete(y8,'2')

Affiche(vw2,vx2,vy2)
